<?php
/*
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
include_once('./nagios_graph_conf.inc.php');
include_once('./nagios_head.inc.php');

if(strlen($size) == 0) {
  if($size_x > 0 && $size_y > 0)
    $size = $size_x."x".$size_y;
  else
    $size = "600x400";
}

print "<form action='display_nagios_info.php' method='GET' id='choose_nagios' style='text-align: center' >\n";

print "<table>"; print "<tr><td>"._("Hostname:")."</td>\n";

$set_current_form = "document.getElementById('choose_nagios').action=''";
$submit_form = "document.getElementById('choose_nagios').submit()";
$unselect_element = "document.getElementById('select_element').value='-1'";
$on_change_goto_self = "onChange=\"$set_current_form;$submit_form;$unselect_element;\"";
$on_change_goto_next = "onChange=\"$submit_form;\"";

// Display list of machine
$nagios_result = mysql_query("SELECT DISTINCT name1 FROM nagios_objects WHERE objecttype_id = '1' ORDER BY name1", $nagios_connection);

print "<td><select name='name1[]' multiple size='6'>\n";

while($result = mysql_fetch_row($nagios_result)) {
  $selected = "";
  foreach($name1 as $nm1) {
    if(strcmp($result[0], $nm1) == 0) { $selected = ' SELECTED ';break; }
  }
  print "  <option value='".$result[0]."'$selected>".$result[0]."</option>\n";
}
print "</select></td>\n";

// Display services available
$request = "
SELECT
  DISTINCT name2
FROM
  nagios_objects
WHERE
  name2 IS NOT NULL";
if(count($name1) > 0) {
  if(strcmp($name1[0], "all") != 0) {
    $request .= " AND name1 IN ('".implode("','", $name1)."') ";
  }
  $request .= " ORDER BY name2";

  $nagios_result = mysql_query($request, $nagios_connection);
  print "<td>"._("Services:")."</td><td><select name='name2[]' multiple size='6'>\n";
  while($result = mysql_fetch_row($nagios_result)) {
    $selected = "";
    foreach($name2 as $nm2) {
      if(strcmp($result[0], $nm2) == 0) { $selected = ' SELECTED '; break; }
    }
    print "  <option value='".$result[0]."'$selected>".$result[0]."</option>\n";
  }
  print "</td></tr>\n";
}

if(is_array($indicators)) {
  $size_indic = count($indicators);
  $size_indic = ($size_indic > 6 ? 6 : $size_indic);
  print "<tr><td rowspan='3'>"._("Indicator:")."</td><td rowspan='3'><select name='indicator[]' multiple size='$size_indic'>\n";
  foreach($indicators as $indic) {
    $selected = "";
    if(is_array($indicator) && count($indicator) > 0) {
      foreach($indicator as $selected_indicator) {
        if(strcmp($indic, $selected_indicator) == 0) {
          $selected = ' SELECTED ';
          break;
        }
      }
    }
    print "  <option value='$indic'$selected>$indic</option>\n";
  }
  print "</select>\n";
  print "<select name='selected_sub_indicator[]' multiple size='5'>\n";
  $i = 0;
  foreach($sub_indicator as $sub) {
    $selected = "";
    if(is_array($selected_sub_indicator) && count($selected_sub_indicator) > 0) {
      foreach($selected_sub_indicator as $elt_sub) {
        if($elt_sub == $i) {
          $selected = ' SELECTED ';
          break;
        }
      }
    }
    if($i == 0) $sub = "avg";
    print "  <option value='$i'$selected>$sub</option>\n";
    $i++;
  }
  print "</select>\n";
  print "</td>\n";
}

print "<td>"._("Export as raw data?")."</td><td><input type='checkbox' name='output_raw_value' value='1' ".($output_raw_value == 1 ? "checked " : "")."/></td></tr>\n";
print "<tr><td>"._("Hide legend?")."</td><td><input type='checkbox' name='hide_legend' value='1' ".($hide_legend == 1 ? "checked " : "")."/></td></tr>\n";
print "<tr><td>"._("Graphic type:")."</td><td><select name='graph_type'>\n";
print "<option value=''>-</option>\n";
$selected = "";
if(strcmp($graph_type, "cumulate_area") == 0)
  $selected = " SELECTED ";
print "<option value='line'$selected>Line Plot</option>\n";
$selected = "";
if(strcmp($graph_type, "cumulate_area") == 0)
  $selected = " SELECTED ";
print "<option value='cumulate_area'$selected>Cumulate area</option>\n";
print "</select>\n";
print "</td></tr>\n";
print "<tr><td>"._("Agregate data:")."</td><td><input type='text' name='agregate' value='$agregate' /></td>\n";
print     "<td>"._("Cumulate?")."</td><td><input type='checkbox' name='cumulate' value='1' ".($cumulate == 1 ? "checked " : "")."/></td></tr>\n";
print "<tr><td>"._("Min:")."</td><td><input type='text' name='min_value' value='$min_value' /></td>\n";
print     "<td>"._("Max:")."</td><td><input type='test' name='max_value' value='$max_value' /></td></tr>\n";
print "<tr><td>"._("Start time:")."</td><td><input type='text' name='start_date' value='$start_date' /></td>\n";
print     "<td>"._("End time:")."</td><td><input type='text' name='end_date' value='$end_date' /></td></tr>\n";
print "<tr><td>"._("Graph size:")."</td><td><input type='text' name='size' value='$size' /></td>\n";
print     "<td>"._("Refresh (s):")."</td><td><input type='input' name='refresh' value='$refresh' /></td></tr>\n";
print "</table>\n";

$yesterday_start = strtotime("-1 day", $start_timestamp);
$yesterday_end = strtotime("-1 day", $end_timestamp);
$yesterday_url = "display_nagios_info.php?".
"name1[]=".implode("name1[]", $name1)."&name2[]=".implode("name2[]", $name2)."&graph_type=$graph_type&agregate=$agregate".
"&min_value=$min_value&max_value=$max_value&start_date=".date("Y-m-d H:i", $yesterday_start).
"&end_date=".date("Y-m-d H:i", $yesterday_end)."&size=$size";

$today_start = strtotime("+1 day", $start_timestamp);
$today_end = strtotime("+1 day", $end_timestamp);
$today_url = "display_nagios_info.php?".
"name1[]=".implode("name1[]", $name1)."&name2[]=".implode("name2[]", $name2)."&graph_type=$graph_type&agregate=$agregate".
"&min_value=$min_value&max_value=$max_value&start_date=".date("Y-m-d H:i", $today_start).
"&end_date=".date("Y-m-d H:i", $today_end)."&size=$size";

print "<p style='text-align: center'><a href='$yesterday_url'>&lt;&lt; -1 day</a> <a href='$today_url'>+1 day &gt;&gt;</a></p>\n";
print "<input type='submit' name='"._("Generate")."' value='"._("Generate")."'>\n";
print "</form>\n";

include_once('./nagios_foot.inc.php');
?>
