#!/bin/bash
# Split up your service_check table into multiple table named service_check_20081001
echo "DANGEROUS SCRIPT !!! USE IT AT YOUR OWN RISK !!!"
echo "DONT TRY THIS THING DIRECTLY ON A REAL PLATFORM"
echo "AT LEAST, MAKE A BACKUP OF YOUR DATA BASE !!!"
exit 2

if [ -f /root/.profile ]; then
. /root/.profile
fi

DEBUG=${DEBUG:-false}
if $DEBUG; then set -x ; fi
rm /tmp/cal.*

mysql_id()
{
  echo "Change your value here"
  exit(1)
  mysql -u mysql_user_for_nagios -ppassword nagios_database $*
}

create_history_table()
{
if $DEBUG; then set -x ; fi
  auto_inc=${2:-"0"}
  mysql_id << EOF
CREATE TABLE $1 (
servicecheck_id int( 11 ) NOT NULL AUTO_INCREMENT ,
instance_id smallint( 6 ) NOT NULL default '0',
service_object_id int( 11 ) NOT NULL default '0',
check_type smallint( 6 ) NOT NULL default '0',
current_check_attempt smallint( 6 ) NOT NULL default '0',
max_check_attempts smallint( 6 ) NOT NULL default '0',
state smallint( 6 ) NOT NULL default '0',
state_type smallint( 6 ) NOT NULL default '0',
start_time datetime NOT NULL default '0000-00-00 00:00:00',
start_time_usec int( 11 ) NOT NULL default '0',
end_time datetime NOT NULL default '0000-00-00 00:00:00',
end_time_usec int( 11 ) NOT NULL default '0',
command_object_id int( 11 ) NOT NULL default '0',
command_args varchar( 255 ) NOT NULL default '',
command_line varchar( 255 ) NOT NULL default '',
timeout smallint( 6 ) NOT NULL default '0',
early_timeout smallint( 6 ) NOT NULL default '0',
execution_time double NOT NULL default '0',
latency double NOT NULL default '0',
return_code smallint( 6 ) NOT NULL default '0',
output varchar( 255 ) NOT NULL default '',
perfdata BLOB NOT NULL default '',
PRIMARY KEY ( servicecheck_id ) ,
UNIQUE KEY instance_id ( instance_id , service_object_id , start_time , start_time_usec ) ,
KEY service_object_id ( service_object_id ) ,
KEY start_time ( start_time )
) ENGINE = InnoDB DEFAULT CHARSET = latin1 COMMENT = 'Historical service checks $1' AUTO_INCREMENT = $auto_inc
EOF

}

year=$(date +%Y)
month=$(date +%m)
day=0
cal $month $year > /tmp/cal.$$
while (( day < 31 ))
do
  let day=day+1
  dday=$(printf "%2.2d" $day)
  dmonth=$(printf "%2.2d" $month)
  if egrep -e" $day | $day$|^$day |^$day$" /tmp/cal.$$ > /dev/null; then
    request="
SELECT
  count(*)
FROM
  nagios_servicechecks
WHERE
  start_time >= '$year-$dmonth-$dday 00:00:00' AND
  start_time <= '$year-$dmonth-$dday 23:59:59'
"
    count=$(mysql_id << EOF | tail -1
$request;
exit
EOF)
    echo "$day/$month/$year count=$count"
    if [ $count = 0 ]; then continue; fi
    request="SHOW TABLE STATUS LIKE 'nagios_servicechecks_$year$dmonth$dday'"
    result=$(mysql_id << EOF 
$request;
exit
EOF)
    auto_increment=$(mysql_id << EOF | awk '{ print $11 }' | tail -1
    SHOW TABLE STATUS LIKE 'nagios_servicechecks'
EOF)
    if echo $result | grep "nagios_servicechecks_$year$dmonth$dday" > /dev/null; then
      echo "Table $year$dmonth$dday deja existante => pas de creation"
    else
      create_history_table nagios_servicechecks_$year$dmonth$dday $auto_increment
    fi
    echo "$(date) Creation et import dans une nouvelle table ($year$dmonth$dday)"
    mysql_id << EOF
RENAME TABLE nagios_servicechecks TO nagios_servicechecks_bak;
EOF
    create_history_table nagios_servicechecks $auto_increment
    mysql_id << EOF
REPLACE INTO
  nagios_servicechecks_$year$dmonth$dday
(
  SELECT
    *
  FROM
    nagios_servicechecks_bak
  WHERE
    start_time >= '$year-$dmonth-$dday 00:00:00' AND
    start_time <= '$year-$dmonth-$dday 23:59:59'
)
;
exit
EOF
  fi
done

mysql_id << EOF
DROP TABLE nagios_servicechecks_bak ;
exit
EOF
